  
//     2020 ,       Turnigy.      FrSky D8  
// PCM .  ,    (5)  ,      Arduino     Timer1B 
//   .   -  990 (1000)  2020 (2000). (?            60 (60-62)
//   -  17  2022. 
// Channe1 0 - .  1000 ()  2000
// Channel 1 - .  1000 ()  2000
// Channel 2 -  .
// Channel 3 -  .  1000 ()  2000
// Channel 4 -     GEAR.    2000   1000
// Channel 5 -  3 AUX3.  995,  1500,  2000
// Channel 6 - ..
//  7 - ..
//  L298 M1
// 10 - in2
// 12 - in1
// 11 - EnA -  (12=0, 10=1 - )

// 7  - in4
// 8  - in3
// 6  - EnB -    (8=1, 7=0 - ; 8=0, 7=1 - )
// ?  - in1()
// 10, 9    , ..    PPM  1

#include <PinChangeInt.h>

#define PPM_PIN 5
#define MAX_PPM_CHANNELS 25

volatile uint16_t temp_time;
volatile uint16_t up_time;
volatile uint16_t d_time;

volatile uint16_t ChannelsCount;
volatile uint16_t Channel[MAX_PPM_CHANNELS];
volatile uint8_t Curr_Channel;// 5  - in2()

char rev = 0;             //   /
char revprev = 0;         //   /  
byte rev_left = 0;        //         
byte rev_right = 0;       //         

void setup() {
  //? digitalWrite(19, HIGH); //       0
  //      PPM 
  pinMode(13, OUTPUT);
  ChannelsCount==0xff;
  Curr_Channel=0;
  TCCR1B   =   0;   //stop timer
  TCCR1A   =   0;
  TCNT1   =    0;   //setup
  TCCR1A   =   0;   
  up_time = 0;
  TCCR1B   =   0<<CS12 | 1<<CS11 | 0<<CS10;//0x1A; //start timer with 1/8
  PCintPort::attachInterrupt(PPM_PIN, CalcPPM, CHANGE);
  //   
  pinMode(0, OUTPUT);
  pinMode(1, OUTPUT);
  pinMode(2, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(12, OUTPUT);
}

void forw(byte enl, byte enr, byte revl, byte revr) {        //  . enl, enr - EnableL,R. revl, revr -  L,R
  if (revr==0) {                                             //   
    digitalWrite(10,HIGH);
    digitalWrite(12,LOW);
  } else {                                                  //   
    digitalWrite(10,LOW);
    digitalWrite(12,HIGH);
  }
  
  if (revl==0) {                                            //   
    digitalWrite(7,HIGH);
    digitalWrite(8,LOW);
  } else {                                                  //   
    digitalWrite(7,LOW);
    digitalWrite(8,HIGH);
  }

  analogWrite(6,enl);                                       //   EnableL
  analogWrite(11, enr);                                     //   EnableR
}

void back(byte enl, byte enr, byte revl, byte revr) {          //  .  
  if (revr==0) {
    digitalWrite(10,LOW);
    digitalWrite(12,HIGH);
  } else {
    digitalWrite(10,HIGH);
    digitalWrite(12,LOW);
  }
  
  if (revl==0) {
    digitalWrite(7,LOW);
    digitalWrite(8,HIGH);
  } else {
    digitalWrite(7,HIGH);
    digitalWrite(8,LOW);
  }
  analogWrite(6,enl);
  analogWrite(11, enr);    
}

void CalcPPM()                  //   PPM 
{
  temp_time = TCNT1;            //     0  2^18 (65535)
  if (!PCintPort::pinState)     //   PCintPort (5 )
  {
    if (up_time>temp_time) d_time=(0xffff-up_time+temp_time)>>1;
    d_time = (temp_time-up_time)>>1;   //     
    up_time = temp_time;
    if (d_time>3500)            //   .     3500 (3,5 )
    {
      //Sync
      ChannelsCount=Curr_Channel;
      Curr_Channel = 0;
    }
    else 
    {
      //Channel
    Channel[Curr_Channel]=d_time; //    
    Curr_Channel++;
    }
  }
}                                 //    PPM 

//  
int speed1 = 0;
int steer1 = 0;
int en_left = 0;
int en_right = 0;

void loop() {                     //  
  delay(150);  

  //      Enable Left, Right
  if (Channel[0]>1000) { speed1=map(Channel[0], 1000, 2000, 0, 255); }    //   (1000-2000)  0..255 PWM
  else { speed1=0; }
  steer1=map(Channel[1], 1000, 2000, -255, 255);                           //  (1000-2000)  -255..255 PWM
  
  en_left=speed1+(steer1);
  if (en_left>255) en_left=255;
  if (en_left<0) {
    rev_left=1;
    en_left=abs(en_left);
  }
  else {
    rev_left=0;
  }
  en_right=speed1-(steer1);
  if (en_right>255) en_right=255;
  if (en_right<0) {
    rev_right=1;
    en_right=abs(en_right);
  }
  else {
    rev_right=0;
  }

  Serial.println("speed1="+String(speed1));  
  Serial.println("steer1="+String(steer1));  
  Serial.println("en_left="+String(en_left));  
  Serial.println("en_right="+String(en_right));  

  //  
  if (Channel[4] < 1300) rev = 0;                                         // 
  if (Channel[4] > 1800) rev = 1;                                         // 
  
  if ((rev == 0) && (revprev == 0)) forw(char(en_left), char(en_right), rev_left, rev_right);   //   
  if ((rev == 0) && (revprev == 1)) {
    forw(0, 0, rev_left, rev_right);                                                            //  .  1  
    delay(1000);
    forw(byte(en_left), byte(en_right), rev_left, rev_right);                                   //  .  1  
  }
  if ((rev == 1) && (revprev == 1)) back(char(en_left), char(en_right), rev_left, rev_right);   //   
  if ((rev == 1) && (revprev == 0)) {
    back(0, 0, rev_left, rev_right);                                                           //  .  1      
    delay(1000);
    back(char(en_left), char(en_right), rev_left, rev_right);                                  //  .  1  
  }
  revprev=rev;
  
}


